// Generated by the protocol buffer compiler.  DO NOT EDIT!
// source: emulator_controller.proto

package com.android.emulator.control;

/**
 * <pre>
 * Provides information about all the displays that can be attached
 * to the emulator. The emulator will always have at least one display.
 *
 * The emulator usually has the following display configurations:
 * 0:      The default display.
 * 1 - 3:  User configurable displays. These can be added/removed.
 *         For example the standalone emulator allows you to modify these
 *         in the extended controls.
 * 6 - 11: Fixed external displays. For example Android Auto uses fixed
 *         displays in this range.
 * </pre>
 *
 * Protobuf type {@code android.emulation.control.DisplayConfigurations}
 */
public final class DisplayConfigurations extends
    com.google.protobuf.GeneratedMessageV3 implements
    // @@protoc_insertion_point(message_implements:android.emulation.control.DisplayConfigurations)
    DisplayConfigurationsOrBuilder {
private static final long serialVersionUID = 0L;
  // Use DisplayConfigurations.newBuilder() to construct.
  private DisplayConfigurations(com.google.protobuf.GeneratedMessageV3.Builder<?> builder) {
    super(builder);
  }
  private DisplayConfigurations() {
    displays_ = java.util.Collections.emptyList();
  }

  @java.lang.Override
  @SuppressWarnings({"unused"})
  protected java.lang.Object newInstance(
      UnusedPrivateParameter unused) {
    return new DisplayConfigurations();
  }

  public static final com.google.protobuf.Descriptors.Descriptor
      getDescriptor() {
    return com.android.emulator.control.EmulatorControllerOuterClass.internal_static_android_emulation_control_DisplayConfigurations_descriptor;
  }

  @java.lang.Override
  protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
      internalGetFieldAccessorTable() {
    return com.android.emulator.control.EmulatorControllerOuterClass.internal_static_android_emulation_control_DisplayConfigurations_fieldAccessorTable
        .ensureFieldAccessorsInitialized(
            com.android.emulator.control.DisplayConfigurations.class, com.android.emulator.control.DisplayConfigurations.Builder.class);
  }

  public static final int DISPLAYS_FIELD_NUMBER = 1;
  @SuppressWarnings("serial")
  private java.util.List<com.android.emulator.control.DisplayConfiguration> displays_;
  /**
   * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
   */
  @java.lang.Override
  public java.util.List<com.android.emulator.control.DisplayConfiguration> getDisplaysList() {
    return displays_;
  }
  /**
   * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
   */
  @java.lang.Override
  public java.util.List<? extends com.android.emulator.control.DisplayConfigurationOrBuilder> 
      getDisplaysOrBuilderList() {
    return displays_;
  }
  /**
   * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
   */
  @java.lang.Override
  public int getDisplaysCount() {
    return displays_.size();
  }
  /**
   * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
   */
  @java.lang.Override
  public com.android.emulator.control.DisplayConfiguration getDisplays(int index) {
    return displays_.get(index);
  }
  /**
   * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
   */
  @java.lang.Override
  public com.android.emulator.control.DisplayConfigurationOrBuilder getDisplaysOrBuilder(
      int index) {
    return displays_.get(index);
  }

  public static final int USERCONFIGURABLE_FIELD_NUMBER = 2;
  private int userConfigurable_ = 0;
  /**
   * <pre>
   * Display configurations with id [1, userConfigurable] are
   * user configurable, that is they can be added, removed or
   * updated.
   * </pre>
   *
   * <code>uint32 userConfigurable = 2;</code>
   * @return The userConfigurable.
   */
  @java.lang.Override
  public int getUserConfigurable() {
    return userConfigurable_;
  }

  public static final int MAXDISPLAYS_FIELD_NUMBER = 3;
  private int maxDisplays_ = 0;
  /**
   * <pre>
   * The maximum number of attached displays this emulator supports.
   * This is the total number of displays that can be attached to
   * the emulator.
   *
   * Note: A display with an id that is larger than userConfigurable cannot
   * be modified.
   * </pre>
   *
   * <code>uint32 maxDisplays = 3;</code>
   * @return The maxDisplays.
   */
  @java.lang.Override
  public int getMaxDisplays() {
    return maxDisplays_;
  }

  private byte memoizedIsInitialized = -1;
  @java.lang.Override
  public final boolean isInitialized() {
    byte isInitialized = memoizedIsInitialized;
    if (isInitialized == 1) return true;
    if (isInitialized == 0) return false;

    memoizedIsInitialized = 1;
    return true;
  }

  @java.lang.Override
  public void writeTo(com.google.protobuf.CodedOutputStream output)
                      throws java.io.IOException {
    for (int i = 0; i < displays_.size(); i++) {
      output.writeMessage(1, displays_.get(i));
    }
    if (userConfigurable_ != 0) {
      output.writeUInt32(2, userConfigurable_);
    }
    if (maxDisplays_ != 0) {
      output.writeUInt32(3, maxDisplays_);
    }
    getUnknownFields().writeTo(output);
  }

  @java.lang.Override
  public int getSerializedSize() {
    int size = memoizedSize;
    if (size != -1) return size;

    size = 0;
    for (int i = 0; i < displays_.size(); i++) {
      size += com.google.protobuf.CodedOutputStream
        .computeMessageSize(1, displays_.get(i));
    }
    if (userConfigurable_ != 0) {
      size += com.google.protobuf.CodedOutputStream
        .computeUInt32Size(2, userConfigurable_);
    }
    if (maxDisplays_ != 0) {
      size += com.google.protobuf.CodedOutputStream
        .computeUInt32Size(3, maxDisplays_);
    }
    size += getUnknownFields().getSerializedSize();
    memoizedSize = size;
    return size;
  }

  @java.lang.Override
  public boolean equals(final java.lang.Object obj) {
    if (obj == this) {
     return true;
    }
    if (!(obj instanceof com.android.emulator.control.DisplayConfigurations)) {
      return super.equals(obj);
    }
    com.android.emulator.control.DisplayConfigurations other = (com.android.emulator.control.DisplayConfigurations) obj;

    if (!getDisplaysList()
        .equals(other.getDisplaysList())) return false;
    if (getUserConfigurable()
        != other.getUserConfigurable()) return false;
    if (getMaxDisplays()
        != other.getMaxDisplays()) return false;
    if (!getUnknownFields().equals(other.getUnknownFields())) return false;
    return true;
  }

  @java.lang.Override
  public int hashCode() {
    if (memoizedHashCode != 0) {
      return memoizedHashCode;
    }
    int hash = 41;
    hash = (19 * hash) + getDescriptor().hashCode();
    if (getDisplaysCount() > 0) {
      hash = (37 * hash) + DISPLAYS_FIELD_NUMBER;
      hash = (53 * hash) + getDisplaysList().hashCode();
    }
    hash = (37 * hash) + USERCONFIGURABLE_FIELD_NUMBER;
    hash = (53 * hash) + getUserConfigurable();
    hash = (37 * hash) + MAXDISPLAYS_FIELD_NUMBER;
    hash = (53 * hash) + getMaxDisplays();
    hash = (29 * hash) + getUnknownFields().hashCode();
    memoizedHashCode = hash;
    return hash;
  }

  public static com.android.emulator.control.DisplayConfigurations parseFrom(
      java.nio.ByteBuffer data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.android.emulator.control.DisplayConfigurations parseFrom(
      java.nio.ByteBuffer data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.android.emulator.control.DisplayConfigurations parseFrom(
      com.google.protobuf.ByteString data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.android.emulator.control.DisplayConfigurations parseFrom(
      com.google.protobuf.ByteString data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.android.emulator.control.DisplayConfigurations parseFrom(byte[] data)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data);
  }
  public static com.android.emulator.control.DisplayConfigurations parseFrom(
      byte[] data,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws com.google.protobuf.InvalidProtocolBufferException {
    return PARSER.parseFrom(data, extensionRegistry);
  }
  public static com.android.emulator.control.DisplayConfigurations parseFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static com.android.emulator.control.DisplayConfigurations parseFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.android.emulator.control.DisplayConfigurations parseDelimitedFrom(java.io.InputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input);
  }
  public static com.android.emulator.control.DisplayConfigurations parseDelimitedFrom(
      java.io.InputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseDelimitedWithIOException(PARSER, input, extensionRegistry);
  }
  public static com.android.emulator.control.DisplayConfigurations parseFrom(
      com.google.protobuf.CodedInputStream input)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input);
  }
  public static com.android.emulator.control.DisplayConfigurations parseFrom(
      com.google.protobuf.CodedInputStream input,
      com.google.protobuf.ExtensionRegistryLite extensionRegistry)
      throws java.io.IOException {
    return com.google.protobuf.GeneratedMessageV3
        .parseWithIOException(PARSER, input, extensionRegistry);
  }

  @java.lang.Override
  public Builder newBuilderForType() { return newBuilder(); }
  public static Builder newBuilder() {
    return DEFAULT_INSTANCE.toBuilder();
  }
  public static Builder newBuilder(com.android.emulator.control.DisplayConfigurations prototype) {
    return DEFAULT_INSTANCE.toBuilder().mergeFrom(prototype);
  }
  @java.lang.Override
  public Builder toBuilder() {
    return this == DEFAULT_INSTANCE
        ? new Builder() : new Builder().mergeFrom(this);
  }

  @java.lang.Override
  protected Builder newBuilderForType(
      com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
    Builder builder = new Builder(parent);
    return builder;
  }
  /**
   * <pre>
   * Provides information about all the displays that can be attached
   * to the emulator. The emulator will always have at least one display.
   *
   * The emulator usually has the following display configurations:
   * 0:      The default display.
   * 1 - 3:  User configurable displays. These can be added/removed.
   *         For example the standalone emulator allows you to modify these
   *         in the extended controls.
   * 6 - 11: Fixed external displays. For example Android Auto uses fixed
   *         displays in this range.
   * </pre>
   *
   * Protobuf type {@code android.emulation.control.DisplayConfigurations}
   */
  public static final class Builder extends
      com.google.protobuf.GeneratedMessageV3.Builder<Builder> implements
      // @@protoc_insertion_point(builder_implements:android.emulation.control.DisplayConfigurations)
      com.android.emulator.control.DisplayConfigurationsOrBuilder {
    public static final com.google.protobuf.Descriptors.Descriptor
        getDescriptor() {
      return com.android.emulator.control.EmulatorControllerOuterClass.internal_static_android_emulation_control_DisplayConfigurations_descriptor;
    }

    @java.lang.Override
    protected com.google.protobuf.GeneratedMessageV3.FieldAccessorTable
        internalGetFieldAccessorTable() {
      return com.android.emulator.control.EmulatorControllerOuterClass.internal_static_android_emulation_control_DisplayConfigurations_fieldAccessorTable
          .ensureFieldAccessorsInitialized(
              com.android.emulator.control.DisplayConfigurations.class, com.android.emulator.control.DisplayConfigurations.Builder.class);
    }

    // Construct using com.android.emulator.control.DisplayConfigurations.newBuilder()
    private Builder() {

    }

    private Builder(
        com.google.protobuf.GeneratedMessageV3.BuilderParent parent) {
      super(parent);

    }
    @java.lang.Override
    public Builder clear() {
      super.clear();
      bitField0_ = 0;
      if (displaysBuilder_ == null) {
        displays_ = java.util.Collections.emptyList();
      } else {
        displays_ = null;
        displaysBuilder_.clear();
      }
      bitField0_ = (bitField0_ & ~0x00000001);
      userConfigurable_ = 0;
      maxDisplays_ = 0;
      return this;
    }

    @java.lang.Override
    public com.google.protobuf.Descriptors.Descriptor
        getDescriptorForType() {
      return com.android.emulator.control.EmulatorControllerOuterClass.internal_static_android_emulation_control_DisplayConfigurations_descriptor;
    }

    @java.lang.Override
    public com.android.emulator.control.DisplayConfigurations getDefaultInstanceForType() {
      return com.android.emulator.control.DisplayConfigurations.getDefaultInstance();
    }

    @java.lang.Override
    public com.android.emulator.control.DisplayConfigurations build() {
      com.android.emulator.control.DisplayConfigurations result = buildPartial();
      if (!result.isInitialized()) {
        throw newUninitializedMessageException(result);
      }
      return result;
    }

    @java.lang.Override
    public com.android.emulator.control.DisplayConfigurations buildPartial() {
      com.android.emulator.control.DisplayConfigurations result = new com.android.emulator.control.DisplayConfigurations(this);
      buildPartialRepeatedFields(result);
      if (bitField0_ != 0) { buildPartial0(result); }
      onBuilt();
      return result;
    }

    private void buildPartialRepeatedFields(com.android.emulator.control.DisplayConfigurations result) {
      if (displaysBuilder_ == null) {
        if (((bitField0_ & 0x00000001) != 0)) {
          displays_ = java.util.Collections.unmodifiableList(displays_);
          bitField0_ = (bitField0_ & ~0x00000001);
        }
        result.displays_ = displays_;
      } else {
        result.displays_ = displaysBuilder_.build();
      }
    }

    private void buildPartial0(com.android.emulator.control.DisplayConfigurations result) {
      int from_bitField0_ = bitField0_;
      if (((from_bitField0_ & 0x00000002) != 0)) {
        result.userConfigurable_ = userConfigurable_;
      }
      if (((from_bitField0_ & 0x00000004) != 0)) {
        result.maxDisplays_ = maxDisplays_;
      }
    }

    @java.lang.Override
    public Builder mergeFrom(com.google.protobuf.Message other) {
      if (other instanceof com.android.emulator.control.DisplayConfigurations) {
        return mergeFrom((com.android.emulator.control.DisplayConfigurations)other);
      } else {
        super.mergeFrom(other);
        return this;
      }
    }

    public Builder mergeFrom(com.android.emulator.control.DisplayConfigurations other) {
      if (other == com.android.emulator.control.DisplayConfigurations.getDefaultInstance()) return this;
      if (displaysBuilder_ == null) {
        if (!other.displays_.isEmpty()) {
          if (displays_.isEmpty()) {
            displays_ = other.displays_;
            bitField0_ = (bitField0_ & ~0x00000001);
          } else {
            ensureDisplaysIsMutable();
            displays_.addAll(other.displays_);
          }
          onChanged();
        }
      } else {
        if (!other.displays_.isEmpty()) {
          if (displaysBuilder_.isEmpty()) {
            displaysBuilder_.dispose();
            displaysBuilder_ = null;
            displays_ = other.displays_;
            bitField0_ = (bitField0_ & ~0x00000001);
            displaysBuilder_ = 
              com.google.protobuf.GeneratedMessageV3.alwaysUseFieldBuilders ?
                 getDisplaysFieldBuilder() : null;
          } else {
            displaysBuilder_.addAllMessages(other.displays_);
          }
        }
      }
      if (other.getUserConfigurable() != 0) {
        setUserConfigurable(other.getUserConfigurable());
      }
      if (other.getMaxDisplays() != 0) {
        setMaxDisplays(other.getMaxDisplays());
      }
      this.mergeUnknownFields(other.getUnknownFields());
      onChanged();
      return this;
    }

    @java.lang.Override
    public final boolean isInitialized() {
      return true;
    }

    @java.lang.Override
    public Builder mergeFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws java.io.IOException {
      if (extensionRegistry == null) {
        throw new java.lang.NullPointerException();
      }
      try {
        boolean done = false;
        while (!done) {
          int tag = input.readTag();
          switch (tag) {
            case 0:
              done = true;
              break;
            case 10: {
              com.android.emulator.control.DisplayConfiguration m =
                  input.readMessage(
                      com.android.emulator.control.DisplayConfiguration.parser(),
                      extensionRegistry);
              if (displaysBuilder_ == null) {
                ensureDisplaysIsMutable();
                displays_.add(m);
              } else {
                displaysBuilder_.addMessage(m);
              }
              break;
            } // case 10
            case 16: {
              userConfigurable_ = input.readUInt32();
              bitField0_ |= 0x00000002;
              break;
            } // case 16
            case 24: {
              maxDisplays_ = input.readUInt32();
              bitField0_ |= 0x00000004;
              break;
            } // case 24
            default: {
              if (!super.parseUnknownField(input, extensionRegistry, tag)) {
                done = true; // was an endgroup tag
              }
              break;
            } // default:
          } // switch (tag)
        } // while (!done)
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.unwrapIOException();
      } finally {
        onChanged();
      } // finally
      return this;
    }
    private int bitField0_;

    private java.util.List<com.android.emulator.control.DisplayConfiguration> displays_ =
      java.util.Collections.emptyList();
    private void ensureDisplaysIsMutable() {
      if (!((bitField0_ & 0x00000001) != 0)) {
        displays_ = new java.util.ArrayList<com.android.emulator.control.DisplayConfiguration>(displays_);
        bitField0_ |= 0x00000001;
       }
    }

    private com.google.protobuf.RepeatedFieldBuilderV3<
        com.android.emulator.control.DisplayConfiguration, com.android.emulator.control.DisplayConfiguration.Builder, com.android.emulator.control.DisplayConfigurationOrBuilder> displaysBuilder_;

    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public java.util.List<com.android.emulator.control.DisplayConfiguration> getDisplaysList() {
      if (displaysBuilder_ == null) {
        return java.util.Collections.unmodifiableList(displays_);
      } else {
        return displaysBuilder_.getMessageList();
      }
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public int getDisplaysCount() {
      if (displaysBuilder_ == null) {
        return displays_.size();
      } else {
        return displaysBuilder_.getCount();
      }
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public com.android.emulator.control.DisplayConfiguration getDisplays(int index) {
      if (displaysBuilder_ == null) {
        return displays_.get(index);
      } else {
        return displaysBuilder_.getMessage(index);
      }
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public Builder setDisplays(
        int index, com.android.emulator.control.DisplayConfiguration value) {
      if (displaysBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureDisplaysIsMutable();
        displays_.set(index, value);
        onChanged();
      } else {
        displaysBuilder_.setMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public Builder setDisplays(
        int index, com.android.emulator.control.DisplayConfiguration.Builder builderForValue) {
      if (displaysBuilder_ == null) {
        ensureDisplaysIsMutable();
        displays_.set(index, builderForValue.build());
        onChanged();
      } else {
        displaysBuilder_.setMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public Builder addDisplays(com.android.emulator.control.DisplayConfiguration value) {
      if (displaysBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureDisplaysIsMutable();
        displays_.add(value);
        onChanged();
      } else {
        displaysBuilder_.addMessage(value);
      }
      return this;
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public Builder addDisplays(
        int index, com.android.emulator.control.DisplayConfiguration value) {
      if (displaysBuilder_ == null) {
        if (value == null) {
          throw new NullPointerException();
        }
        ensureDisplaysIsMutable();
        displays_.add(index, value);
        onChanged();
      } else {
        displaysBuilder_.addMessage(index, value);
      }
      return this;
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public Builder addDisplays(
        com.android.emulator.control.DisplayConfiguration.Builder builderForValue) {
      if (displaysBuilder_ == null) {
        ensureDisplaysIsMutable();
        displays_.add(builderForValue.build());
        onChanged();
      } else {
        displaysBuilder_.addMessage(builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public Builder addDisplays(
        int index, com.android.emulator.control.DisplayConfiguration.Builder builderForValue) {
      if (displaysBuilder_ == null) {
        ensureDisplaysIsMutable();
        displays_.add(index, builderForValue.build());
        onChanged();
      } else {
        displaysBuilder_.addMessage(index, builderForValue.build());
      }
      return this;
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public Builder addAllDisplays(
        java.lang.Iterable<? extends com.android.emulator.control.DisplayConfiguration> values) {
      if (displaysBuilder_ == null) {
        ensureDisplaysIsMutable();
        com.google.protobuf.AbstractMessageLite.Builder.addAll(
            values, displays_);
        onChanged();
      } else {
        displaysBuilder_.addAllMessages(values);
      }
      return this;
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public Builder clearDisplays() {
      if (displaysBuilder_ == null) {
        displays_ = java.util.Collections.emptyList();
        bitField0_ = (bitField0_ & ~0x00000001);
        onChanged();
      } else {
        displaysBuilder_.clear();
      }
      return this;
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public Builder removeDisplays(int index) {
      if (displaysBuilder_ == null) {
        ensureDisplaysIsMutable();
        displays_.remove(index);
        onChanged();
      } else {
        displaysBuilder_.remove(index);
      }
      return this;
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public com.android.emulator.control.DisplayConfiguration.Builder getDisplaysBuilder(
        int index) {
      return getDisplaysFieldBuilder().getBuilder(index);
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public com.android.emulator.control.DisplayConfigurationOrBuilder getDisplaysOrBuilder(
        int index) {
      if (displaysBuilder_ == null) {
        return displays_.get(index);  } else {
        return displaysBuilder_.getMessageOrBuilder(index);
      }
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public java.util.List<? extends com.android.emulator.control.DisplayConfigurationOrBuilder> 
         getDisplaysOrBuilderList() {
      if (displaysBuilder_ != null) {
        return displaysBuilder_.getMessageOrBuilderList();
      } else {
        return java.util.Collections.unmodifiableList(displays_);
      }
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public com.android.emulator.control.DisplayConfiguration.Builder addDisplaysBuilder() {
      return getDisplaysFieldBuilder().addBuilder(
          com.android.emulator.control.DisplayConfiguration.getDefaultInstance());
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public com.android.emulator.control.DisplayConfiguration.Builder addDisplaysBuilder(
        int index) {
      return getDisplaysFieldBuilder().addBuilder(
          index, com.android.emulator.control.DisplayConfiguration.getDefaultInstance());
    }
    /**
     * <code>repeated .android.emulation.control.DisplayConfiguration displays = 1;</code>
     */
    public java.util.List<com.android.emulator.control.DisplayConfiguration.Builder> 
         getDisplaysBuilderList() {
      return getDisplaysFieldBuilder().getBuilderList();
    }
    private com.google.protobuf.RepeatedFieldBuilderV3<
        com.android.emulator.control.DisplayConfiguration, com.android.emulator.control.DisplayConfiguration.Builder, com.android.emulator.control.DisplayConfigurationOrBuilder> 
        getDisplaysFieldBuilder() {
      if (displaysBuilder_ == null) {
        displaysBuilder_ = new com.google.protobuf.RepeatedFieldBuilderV3<
            com.android.emulator.control.DisplayConfiguration, com.android.emulator.control.DisplayConfiguration.Builder, com.android.emulator.control.DisplayConfigurationOrBuilder>(
                displays_,
                ((bitField0_ & 0x00000001) != 0),
                getParentForChildren(),
                isClean());
        displays_ = null;
      }
      return displaysBuilder_;
    }

    private int userConfigurable_ ;
    /**
     * <pre>
     * Display configurations with id [1, userConfigurable] are
     * user configurable, that is they can be added, removed or
     * updated.
     * </pre>
     *
     * <code>uint32 userConfigurable = 2;</code>
     * @return The userConfigurable.
     */
    @java.lang.Override
    public int getUserConfigurable() {
      return userConfigurable_;
    }
    /**
     * <pre>
     * Display configurations with id [1, userConfigurable] are
     * user configurable, that is they can be added, removed or
     * updated.
     * </pre>
     *
     * <code>uint32 userConfigurable = 2;</code>
     * @param value The userConfigurable to set.
     * @return This builder for chaining.
     */
    public Builder setUserConfigurable(int value) {

      userConfigurable_ = value;
      bitField0_ |= 0x00000002;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * Display configurations with id [1, userConfigurable] are
     * user configurable, that is they can be added, removed or
     * updated.
     * </pre>
     *
     * <code>uint32 userConfigurable = 2;</code>
     * @return This builder for chaining.
     */
    public Builder clearUserConfigurable() {
      bitField0_ = (bitField0_ & ~0x00000002);
      userConfigurable_ = 0;
      onChanged();
      return this;
    }

    private int maxDisplays_ ;
    /**
     * <pre>
     * The maximum number of attached displays this emulator supports.
     * This is the total number of displays that can be attached to
     * the emulator.
     *
     * Note: A display with an id that is larger than userConfigurable cannot
     * be modified.
     * </pre>
     *
     * <code>uint32 maxDisplays = 3;</code>
     * @return The maxDisplays.
     */
    @java.lang.Override
    public int getMaxDisplays() {
      return maxDisplays_;
    }
    /**
     * <pre>
     * The maximum number of attached displays this emulator supports.
     * This is the total number of displays that can be attached to
     * the emulator.
     *
     * Note: A display with an id that is larger than userConfigurable cannot
     * be modified.
     * </pre>
     *
     * <code>uint32 maxDisplays = 3;</code>
     * @param value The maxDisplays to set.
     * @return This builder for chaining.
     */
    public Builder setMaxDisplays(int value) {

      maxDisplays_ = value;
      bitField0_ |= 0x00000004;
      onChanged();
      return this;
    }
    /**
     * <pre>
     * The maximum number of attached displays this emulator supports.
     * This is the total number of displays that can be attached to
     * the emulator.
     *
     * Note: A display with an id that is larger than userConfigurable cannot
     * be modified.
     * </pre>
     *
     * <code>uint32 maxDisplays = 3;</code>
     * @return This builder for chaining.
     */
    public Builder clearMaxDisplays() {
      bitField0_ = (bitField0_ & ~0x00000004);
      maxDisplays_ = 0;
      onChanged();
      return this;
    }
    @java.lang.Override
    public final Builder setUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.setUnknownFields(unknownFields);
    }

    @java.lang.Override
    public final Builder mergeUnknownFields(
        final com.google.protobuf.UnknownFieldSet unknownFields) {
      return super.mergeUnknownFields(unknownFields);
    }


    // @@protoc_insertion_point(builder_scope:android.emulation.control.DisplayConfigurations)
  }

  // @@protoc_insertion_point(class_scope:android.emulation.control.DisplayConfigurations)
  private static final com.android.emulator.control.DisplayConfigurations DEFAULT_INSTANCE;
  static {
    DEFAULT_INSTANCE = new com.android.emulator.control.DisplayConfigurations();
  }

  public static com.android.emulator.control.DisplayConfigurations getDefaultInstance() {
    return DEFAULT_INSTANCE;
  }

  private static final com.google.protobuf.Parser<DisplayConfigurations>
      PARSER = new com.google.protobuf.AbstractParser<DisplayConfigurations>() {
    @java.lang.Override
    public DisplayConfigurations parsePartialFrom(
        com.google.protobuf.CodedInputStream input,
        com.google.protobuf.ExtensionRegistryLite extensionRegistry)
        throws com.google.protobuf.InvalidProtocolBufferException {
      Builder builder = newBuilder();
      try {
        builder.mergeFrom(input, extensionRegistry);
      } catch (com.google.protobuf.InvalidProtocolBufferException e) {
        throw e.setUnfinishedMessage(builder.buildPartial());
      } catch (com.google.protobuf.UninitializedMessageException e) {
        throw e.asInvalidProtocolBufferException().setUnfinishedMessage(builder.buildPartial());
      } catch (java.io.IOException e) {
        throw new com.google.protobuf.InvalidProtocolBufferException(e)
            .setUnfinishedMessage(builder.buildPartial());
      }
      return builder.buildPartial();
    }
  };

  public static com.google.protobuf.Parser<DisplayConfigurations> parser() {
    return PARSER;
  }

  @java.lang.Override
  public com.google.protobuf.Parser<DisplayConfigurations> getParserForType() {
    return PARSER;
  }

  @java.lang.Override
  public com.android.emulator.control.DisplayConfigurations getDefaultInstanceForType() {
    return DEFAULT_INSTANCE;
  }

}

